using System.Text.Json;
using CFCoreAPI.Endpoints.Categories.Responses;
using Microsoft.AspNetCore.WebUtilities;

namespace CFCoreAPI.Endpoints.Categories
{
    public class CategoriesAPI : APIBase
    {
        public CategoriesAPI(HttpClient httpClient) : base(httpClient)
        {
        }

        public async Task<CategoriesResponse> GetCategories(int gameId, int? classId)
        {
            string url = "/v1/categories";
            url = QueryHelpers.AddQueryString(url, "gameId", gameId.ToString());
            if (classId != null) url = QueryHelpers.AddQueryString(url, "classId", classId.ToString());
            HttpResponseMessage response = await httpClient.GetAsync(url);

            CategoriesResponse result;
            using (Stream contentStream = await response.Content.ReadAsStreamAsync())
            {
                result = (await JsonSerializer.DeserializeAsync<CategoriesResponse>(contentStream))!;
            }
            return result;
        }
    }
}