using System.Text.Json.Serialization;

namespace CFCoreAPI.Endpoints.Categories.Responses
{
    public class CategoriesResponse
    {
        [JsonConstructor]
        public CategoriesResponse(
            List<DataModel> data
        )
        {
            this.Data = data;
        }

        public IReadOnlyList<DataModel> Data { get; }

        public class DataModel
        {
            [JsonConstructor]
            public DataModel(
                int id,
                int gameId,
                string name,
                string slug,
                string url,
                string iconUrl,
                DateTime dateModified,
                bool isClass,
                int classId,
                int parentCategoryId,
                int displayIndex
            )
            {
                this.Id = id;
                this.GameId = gameId;
                this.Name = name;
                this.Slug = slug;
                this.Url = url;
                this.IconUrl = iconUrl;
                this.DateModified = dateModified;
                this.IsClass = isClass;
                this.ClassId = classId;
                this.ParentCategoryId = parentCategoryId;
                this.DisplayIndex = displayIndex;
            }

            public int Id { get; }
            public int GameId { get; }
            public string Name { get; }
            public string Slug { get; }
            public string Url { get; }
            public string IconUrl { get; }
            public DateTime DateModified { get; }
            public bool IsClass { get; }
            public int ClassId { get; }
            public int ParentCategoryId { get; }
            public int DisplayIndex { get; }
        }
    }


}